unit ReplaceDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AppUtils, Placemnt, Mwcustomedit;

type
  TdlgReplace = class(TForm)
    cbFindText: TEdit;
    cbReplaceText: TEdit;
    procedure btnCloseClick(Sender: TObject);
    public
     searchoptions : TmwSearchOptions;
    published
    GroupBox1: TGroupBox;
    Label1: TLabel;
    btnClose: TButton;
    cbMatchCase: TCheckBox;
    cbWholeWord: TCheckBox;
    GroupBox2: TGroupBox;
    rbForward: TRadioButton;
    rbBackward: TRadioButton;
    GroupBox3: TGroupBox;
    rbGlobal: TRadioButton;
    rbSelectedOnly: TRadioButton;
    GroupBox4: TGroupBox;
    rbFromCursor: TRadioButton;
    rbEntireScope: TRadioButton;
    Label2: TLabel;
    btnReplaceAll: TButton;
    cbPrompt: TCheckBox;
    FormStorage: TFormStorage;
    btnReplace: TButton;
    btnSearch: TButton;
    procedure btnSearchClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cbFindTextChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnReplaceClick(Sender: TObject);
    procedure cbClick(Sender: TObject);
    procedure rbClick(Sender: TObject);
    procedure btnReplaceAllClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dlgReplace: TdlgReplace;

// Adapted from the MWEdit example
(************************************************************************************)
implementation
uses testmwunit;
{$R *.DFM}
(************************************************************************************)
procedure TdlgReplace.btnSearchClick(Sender: TObject);
begin
   exclude(searchoptions, mwsoReplace); // set search options only (not replace opts')
   if Editform.mwCustomEdit1.SearchReplace(cbfindtext.text,'',searchoptions) = 0 then
      ShowMessage('Search String not found')
   else
      with Editform.mwCustomEdit1 do
         begin
           btnsearch.caption := '&Find Next';         // start from current position
           exclude(SearchOptions,mwsoEntireScope);    // if searching for next match
           rbfromcursor.checked := true;
         end;
end;
(************************************************************************************)
procedure TdlgReplace.FormShow(Sender: TObject);      // initialize the option
begin                                                 // checkboxes and radio buttons
   btnsearch.caption := '&Find';
   searchoptions :=[];
   if cbMatchCase.Checked then
      include(SearchOptions, mwsoMatchCase);
   if cbWholeWord.Checked then
      include(SearchOptions, mwsoWholeWord);
   if rbBackward.Checked then
      include(SearchOptions, mwsoBackwards);
   if rbSelectedOnly.Checked then
      include(SearchOptions, mwsoSelectedOnly);
   if rbEntireScope.Checked then
      include(SearchOptions, mwsoEntireScope);
end;
(************************************************************************************)
procedure TdlgReplace.cbFindTextChange(Sender: TObject);
begin
   btnSearch.caption := '&Find';
end;
(************************************************************************************)
procedure TdlgReplace.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);                   // handles keyboard shortcuts
begin
  case key of
    vk_F3      : btnSearch.Click;
    vk_return  : btnsearch.click;
    vk_escape  : btnclose.click;
  end
end;
(************************************************************************************)
procedure TdlgReplace.btnReplaceClick(Sender: TObject);
begin                                        // this time include the replace options
   include(searchoptions, mwsoReplace);      // and replace the specified text 
   if EditForm.mwCustomEdit1.SearchReplace(cbfindtext.text,
                                        cbReplacetext.text,searchoptions) = 0 then
      ShowMessage('Search String not found')
   else
      with Editform.mwCustomEdit1 do
         begin
           exclude(SearchOptions,mwsoEntireScope);
           rbfromcursor.checked := true;
         end;
end;
(************************************************************************************)
procedure TdlgReplace.cbClick(Sender: TObject);
begin                                  // handle an option toggle (checkboxes only)
  if cbmatchcase.Checked then
     include(searchoptions, mwsoMatchCase)   // case sensitive search
  else
     exclude(searchoptions, mwsoMatchCase);  // case insensitive
  if cbWholeWord.Checked then
     include(searchoptions, mwsoWholeWord)   // whole words only
  else
     exclude(searchoptions, mwsoWholeword);  // substring search
  if cbPrompt.Checked then
     include(searchoptions, mwsoPrompt)      // prompt on replace
  else
     exclude(searchoptions, mwsoPrompt)      // no prompt
end;
(************************************************************************************)
procedure TdlgReplace.rbClick(Sender: TObject);
begin                                  // handle an option toggle (radiobuttons only)
   if rbGlobal.Checked then
      exclude(SearchOptions, mwsoSelectedOnly)   // search/replace scope : selection only
   else
      include(SearchOptions, mwsoSelectedOnly);  //        //            : global 
   if rbforward.Checked then
      exclude(SearchOptions, mwsoBackwards)      // search direction : backwards
   else
      include(SearchOptions, mwsoBackwards);     //        //        : forward 
   if rbFromCursor.checked then
      exclude(SearchOptions, mwsoEntireScope)    // search from beginning
   else
      include(SearchOptions, mwsoEntireScope);   // search from current cursor position
end;
(************************************************************************************)
procedure TdlgReplace.btnReplaceAllClick(Sender: TObject);
begin                                        // replaces all occurrences of specified text
   include(searchoptions, mwsoReplace);      // with the text entered in the cbReplace
   include(searchoptions, mwsoReplaceAll);   // edit box
   EditForm.mwcustomedit1.BeginUpdate;          // lock the edit control until all matches
   if EditForm.mwCustomEdit1.SearchReplace(cbfindtext.text,          // have been replaced
                                        cbReplacetext.text,searchoptions) = 0 then
      ShowMessage('Search String not found');
   EditForm.mwcustomedit1.endupdate;
end;
(************************************************************************************)
procedure TdlgReplace.btnCloseClick(Sender: TObject);
begin                                         // hide the search/replace dialog box
    dlgreplace.Hide;
end;
(************************************************************************************)
end.
